Примеры использования
=====================


i2pd может быть использован для:

* [анонимных веб-сайтов](#browsing-and-hosting-websites)
* [анонимных чатов](#using-and-hosting-chat-servers)
* [анонимного файлообмена](#file-sharing)

и для много чего еще.

<a name="browsing-and-hosting-websites"></a>
## Посещение и создание веб-сайтов 

### Посещение анонимных веб-сайтов

Чтобы посещать анонимные веб-сайты внутри Невидимого Интернета, настройте свой веб-браузер на использование HTTP прокси 127.0.0.1:4444 (включено по-умолчанию в i2pd).

В Firefox: Настройки -> Дополнительные -> Сеть -> Соединение -> Настроить -> выберите Ручная настройка сервиса прокси, введите HTTP прокси 127.0.0.1, Порт 4444.

В Chromium: запустите chromium с ключом

    chromium --proxy-server="http://127.0.0.1:4444"

Если вы хотите остаться анонимным при посещении веб-сайтов, вам необходимо так же настроить свой веб-браузер для защиты от деанонимизации. Как именно это делается можно найти в интернете, например [здесь](https://habrahabr.ru/post/203680/).

Большой список сайтов Невидимого Интернета на сайте [identiguy.i2p](http://identiguy.i2p).

### Создание анонимных веб-сайтов


Если вы хотите запустить свой сайт в Невидимом Интернете, следуйте данной инструкции:

1)  Запустите веб-сервер и узнайте, какой хост:порт он использует (например, 127.0.0.1:8080).

2)  Настройте i2pd для создания серверного HTTP туннеля. В файл ~/.i2pd/tunnels.conf добавьте:

        [anon-website]
        type = http
        host = 127.0.0.1
        port = 8080
        keys = anon-website.dat

3)  Перезапустите i2pd.

4)  Найдите b32 destination вашего вебсайта.

    Зайдите в веб-консоль -> [страница I2P tunnels](http://127.0.0.1:7070/?page=i2p_tunnels). Ищите Sever tunnels и увидете адрес \<длинная строка\>.b32.i2p рядом с anon-website. 
  
    Теперь веб-сайт доступен в Невидимом Интернете по этому адресу.

5)  (Опционально) Зарегистрируйте короткий и запоминающийся .i2p домен на [inr.i2p](http://inr.i2p).


<a name="using-and-hosting-chat-servers"></a>
## Использование и создание чат-серверов

### Запуск анонимного IRC сервера

1)  Запустите свой IRC сервер и узнайте, какой хост:порт он использует (например, 127.0.0.1:5555). 

    Для малых приватных IRC серверов вы можете использовать [miniircd](https://github.com/jrosdahl/miniircd), для больших публичных [UnreadIRCd](https://www.unrealircd.org/).

2)  Настройте i2pd для создания серверного IRC туннеля. 

    В самом простом случае, если ваш сервер не поддерживает WebIRC, добавьте следующее в ~/.i2pd/tunnels.conf:

        [anon-chatserver]
        type = irc
        host = 127.0.0.1     
        port = 5555
        keys = chatserver-key.dat

    И этого достаточно.

    В случае, если ваш IRC сервер поддерживает WebIRC, например, это UnrealIRCd, добавьте следущее в конфиг UnrealIRCd:

        webirc {
            mask 127.0.0.1;
            password your_password;
        };

    Также измените строку:

        modes-on-connect "+ixw";

    на

        modes-on-connect "+iw";

    И добавьте это в ~/.i2pd/tunnels.conf:

        [anon-chatserver]
        type = irc
        host = 127.0.0.1
        port = 5555
        keys = chatserver-key.dat
        webircpassword = your_password

3)  Перезапустите i2pd.

4)  Найдите b32 destination вашего анонимного IRC сервера.

    Зайдите в веб-консоль -> [страница I2P tunnels](http://127.0.0.1:7070/?page=i2p_tunnels). Ищите Sever tunnels и увидете адрес \<длинная строка\>.b32.i2p рядом с anon-chatserver.

    Пользователи будут использовать этот адрес для анонимного подключения к вашему серверу.

### Подключение к анонимному IRC серверу

Чтобы подключиться к IRC серверу по адресу *walker.i2p*, добавьте следующее в ~/.i2pd/tunnels.conf:

    [IRC2]
    type = client
    address = 127.0.0.1
    port = 6669
    destination = walker.i2p
    #keys = walker-keys.dat

Перезапустите i2pd, после чего подключайтесь к irc://127.0.0.1:6669 в вашем IRC клиенте.

<a name="file-sharing"></a>
## Файлообмен 

Вы можете качать и раздавать торренты клиентом [Transmission-I2P](https://github.com/l-n-s/transmission-i2p).

Другие торрент-клиенты [Robert](http://en.wikipedia.org/wiki/Robert_%28P2P_Software%29) и [Vuze](https://en.wikipedia.org/wiki/Vuze).

Robert использует протокол BOB, i2pd должен быть запущен с настройкой --bob.enabled=true.

Vuze использует протокол I2CP, i2pd должен быть запущен с настройкой --i2cp.enabled=true.

Используйте [трекер postman](http://tracker2.postman.i2p).
